# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 747 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/get_plot_trail.al)"
sub get_plot_trail {
  require GPS::Lowrance::Trail;

  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  my %input = @_;

  my $raw_trail = $self->get_plot_trail_mercator_meters( %input );

  if (defined $raw_trail) {

    my $trail = new GPS::Lowrance::Trail(
      rounding  => $input{rounding}||0,
      trail_num => $input{plot_trail_number} + 1,
    );
    assert( UNIVERSAL::isa( $trail, "GPS::Lowrance::Trail" ) ), if DEBUG;

    foreach my $pt (@$raw_trail) {
      $trail->add_point( mercator_meters_to_degrees( @{$pt}[0..1] ),
			 @{$pt}[2..-1] );
    }
    assert( $trail->size == scalar(@$raw_trail) ), if DEBUG;

    return $trail;
  } else {
    return;
  }
}

# end of GPS::Lowrance::get_plot_trail
1;
