# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 690 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/get_plot_trail_mercator_meters.al)"
sub get_plot_trail_mercator_meters {
  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  if ($self->get_protocol_version < 1) {
    die "this method requires protocol version 2.0";
  }

  my %input    = @_;

  if ($self->get_num_of_plot_trails <= $input{plot_trail_number}) {
    die "plot_trail_number too high";
  }

  my $callback = $input{callback} || sub { return; };
  assert( ref($callback) eq "CODE" ), if DEBUG;

  my $origin   = $self->get_plot_trail_origin( %input );

  my ($origin_x, $origin_y, $delta_count) =
    map { ( ( $origin->{$_} ) ) } (
     qw( origin_x origin_y number_of_deltas ) );

  my @trail = ( [ $origin_y, $origin_x ] );

  my $expected = $delta_count+1;

  while ($delta_count) {

    &{$callback}( scalar(@trail) . "/" . $expected );

    # LSI protocol says that no more than 40 deltas should be
    # downloaded at a time

    $input{number_of_deltas} =
      ($delta_count > MAX_DELTAS) ? MAX_DELTAS : $delta_count;
    $delta_count -= $input{number_of_deltas};

    my $deltas = $self->get_plot_trail_deltas(%input);

    die "unable to retrieve deltas",
      unless ($deltas->{number_of_deltas} == $input{number_of_deltas});

    for my $i (1 .. $input{number_of_deltas}) {
      my ($x, $y) = map { ( ( $deltas->{$_."_$i"}||0) ) } (
        qw( delta_x delta_y ) );
      $origin_x += $x;
      $origin_y += $y;
      push @trail, [ $origin_y, $origin_x ];
    }

  }

  &{$callback}( scalar(@trail) . "/" . $expected );
  return \@trail;
}

# end of GPS::Lowrance::get_plot_trail_mercator_meters
1;
