# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 482 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/get_waypoints.al)"
sub get_waypoints {
  require GPS::Lowrance::Waypoints;

  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  my %input    = @_;

  my $callback = $input{callback} || sub { return; };
  assert( ref($callback) eq "CODE" ), if DEBUG;

  my $list     = $input{waypoints} || [1..$self->get_num_of_waypoints];
  assert( ref($list) eq "ARRAY" ), if DEBUG;

  my $list_size = scalar @$list;

  my $waypoints  = new GPS::Lowrance::Waypoints( rounding => 0 );

  foreach my $num (@$list) {

    if ($num > $self->get_num_of_waypoints) {
      die "invalid waypoint number ``$num\'\'";
    }

    &{$callback}( $waypoints->size . "/" . $list_size );

    my $wpt = $self->get_a_waypoint( waypoint_number => $num-1 );

    if ($wpt->{status}) {
      # We eval it, and if the data is invalid, we don't add it.
      eval {
	$waypoints->add_point(
           mercator_meters_to_degrees( $wpt->{latitude}, $wpt->{longitude} ),
           $wpt->{name},
           gps_to_unix_time( $wpt->{date} ),
           $num-1,
           $wpt->{icon_symbol} );
      };
    }
  }

  &{$callback}( $waypoints->size . "/" . $list_size );

  return $waypoints;
}

# end of GPS::Lowrance::get_waypoints
1;
